"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getField = void 0;
var console_messages_1 = require("../../../cli/console/console.messages");
var format_field_1 = require("./format-field");
var get_list_1 = require("./get-list");
var translate_type_1 = require("./translate-type");
var handleType = function (fieldName, type, isFunction, isNull) {
    var _a;
    if (type.kind === 'LIST') {
        var underlying = (_a = type.ofType) === null || _a === void 0 ? void 0 : _a.ofType;
        return (0, get_list_1.getList)(underlying === null || underlying === void 0 ? void 0 : underlying.kind, fieldName, underlying === null || underlying === void 0 ? void 0 : underlying.name, isFunction, isNull);
    }
    else if (type.kind === 'OBJECT' || type.kind === 'INPUT_OBJECT') {
        return (0, format_field_1.formatField)(fieldName, type.name, isFunction, isNull);
    }
    else if (type.kind === 'SCALAR') {
        return (0, format_field_1.formatField)(fieldName, (0, translate_type_1.translatedType)(type.name), isFunction, isNull);
    }
    else if (type.kind === 'ENUM') {
        return (0, format_field_1.formatField)(fieldName, type.name, isFunction, isNull);
    }
    (0, console_messages_1.displayWarning)("Unhandled field ".concat(fieldName, " of type ").concat(type));
    return '';
};
var getField = function (field, isFunction) {
    if (field.defaultValue) {
        return (0, format_field_1.formatField)(field.name, field.defaultValue, isFunction, false);
    }
    if (field.name) {
        if (field.type.kind === 'NON_NULL') {
            return handleType(field.name, field.type.ofType, isFunction, false);
        }
        return handleType(field.name, field.type, isFunction, true);
    }
};
exports.getField = getField;
