"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getList = void 0;
var console_messages_1 = require("../../../cli/console/console.messages");
var format_field_1 = require("./format-field");
var translate_type_1 = require("./translate-type");
var getList = function (kind, name, type, isFunction, isNull) {
    if (kind === 'OBJECT' || kind === 'INPUT_OBJECT') {
        return (0, format_field_1.formatField)(name, "Array<".concat(type, ">"), isFunction, isNull);
    }
    else if (kind === 'SCALAR') {
        return (0, format_field_1.formatField)(name, "Array<".concat((0, translate_type_1.translatedType)(type), ">"), isFunction, isNull);
    }
    (0, console_messages_1.displayWarning)("List parsing: unhandled field 'name' for kind ".concat(kind, " and type ").concat(type));
    return '';
};
exports.getList = getList;
