"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseGraphqlObject = void 0;
var capitalize_1 = require("../../util/capitalize");
var get_field_1 = require("./fields-handling/get-field");
var parseGraphqlObject = function (name, fields) {
    if (!fields) {
        return { output: '', argsTypes: '', argsCount: 0 };
    }
    var result = fields.reduce(function (out, field) {
        if (field.args && field.args.length > 0) {
            var outputType = (0, get_field_1.getField)(field, true);
            var functionDefinition = "".concat(field.name, ": (").concat(field.args
                .map(function (arg) { return (0, get_field_1.getField)(arg, true); })
                .join(', '), ") =>").concat(outputType === null || outputType === void 0 ? void 0 : outputType.split(':')[1]);
            out.output += "".concat(functionDefinition, "; ");
            out.argsTypes += "export type ".concat((0, capitalize_1.capitalize)(field.name)).concat(name, "Args = { ").concat(field.args
                .map(function (arg) { return (0, get_field_1.getField)(arg, true); })
                .join(', '), " };\n");
            out.argsCount += 1;
        }
        else {
            out.output += (0, get_field_1.getField)(field, false);
        }
        return out;
    }, { output: '', argsTypes: '', argsCount: 0 });
    return __assign(__assign({}, result), { output: "export interface ".concat(name, " { ").concat(result.output, "}\n") });
};
exports.parseGraphqlObject = parseGraphqlObject;
