"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.translateTypesToTs = void 0;
var parse_graphql_object_1 = require("./parse-graphql-object");
var translateTypesToTs = function (input) {
    var count = 0;
    var rootObjectsName = [];
    var argsTypesOutput = '';
    var output = input.reduce(function (acc, _a) {
        var kind = _a.kind, name = _a.name, fields = _a.fields, inputFields = _a.inputFields, enumValues = _a.enumValues;
        if (name.startsWith('__')) {
            return acc;
        }
        if (kind === 'OBJECT' || kind === 'INPUT_OBJECT') {
            rootObjectsName.push(name);
            var target = kind === 'OBJECT' ? fields : inputFields;
            var _b = (0, parse_graphql_object_1.parseGraphqlObject)(name, target), argsTypes = _b.argsTypes, output_1 = _b.output, argsCount = _b.argsCount;
            acc += output_1;
            argsTypesOutput += argsTypes;
            count += argsCount + 1;
        }
        else if (kind === 'ENUM') {
            var typeOutput = "export type ".concat(name, " = ").concat(enumValues === null || enumValues === void 0 ? void 0 : enumValues.map(function (v) { return "'".concat(v.name, "'"); }).join(' | '));
            acc += "".concat(typeOutput, ";\n");
            count++;
        }
        return acc;
    }, '');
    return {
        types: "/* eslint-disable */\n/* tslint:disable */\n\n".concat(output, "\n").concat(argsTypesOutput),
        count: count,
        rootObjectsName: rootObjectsName,
    };
};
exports.translateTypesToTs = translateTypesToTs;
