"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateFromUrl = void 0;
var fs_extra_1 = require("fs-extra");
var fetch_graphql_schema_1 = require("../logic/fetching/fetch-graphql-schema");
var generate_index_1 = require("../logic/file-generation/generate-index");
var generate_output_code_chunks_1 = require("../logic/file-generation/generate-output-code-chunks");
var generate_selectors_1 = require("../logic/file-generation/generate-selectors");
var generate_mutations_1 = require("../logic/file-generation/mutations/generate-mutations");
var generate_queries_1 = require("../logic/file-generation/queries/generate-queries");
var generate_query_replacer_1 = require("../logic/parsing/query-replacer/generate-query-replacer");
var translate_types_to_ts_1 = require("../logic/parsing/types/translate-types-to-ts");
var get_endpoints_objects_1 = require("./get-endpoints-objects");
var generateFromUrl = function (_a) {
    var schemaUrl = _a.schemaUrl, outputPath = _a.outputPath, fetcherPath = _a.fetcherPath;
    return __awaiter(void 0, void 0, void 0, function () {
        var schemaTypes, _b, queryObject, mutationObject, _c, types, rootObjectsName, count, queryReplacer;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0: return [4 /*yield*/, (0, fetch_graphql_schema_1.fetchGraphqlSchema)(schemaUrl)];
                case 1:
                    schemaTypes = _d.sent();
                    _b = (0, get_endpoints_objects_1.getEndpointsObjects)(schemaTypes), queryObject = _b.queryObject, mutationObject = _b.mutationObject;
                    _c = (0, translate_types_to_ts_1.translateTypesToTs)(schemaTypes), types = _c.types, rootObjectsName = _c.rootObjectsName, count = _c.count;
                    return [4 /*yield*/, (0, fs_extra_1.ensureDir)("".concat(outputPath, "/types"))];
                case 2:
                    _d.sent();
                    return [4 /*yield*/, (0, fs_extra_1.writeFile)("".concat(outputPath, "/types/api-types.ts"), types)];
                case 3:
                    _d.sent();
                    return [4 /*yield*/, (0, generate_selectors_1.generateSelectors)(queryObject, types, rootObjectsName, outputPath)];
                case 4:
                    _d.sent();
                    return [4 /*yield*/, (0, fs_extra_1.ensureDir)("".concat(outputPath, "/logic"))];
                case 5:
                    _d.sent();
                    queryReplacer = (0, generate_query_replacer_1.generateQueryReplacer)(queryObject);
                    return [4 /*yield*/, (0, fs_extra_1.writeFile)("".concat(outputPath, "/logic/query-replacer.ts"), queryReplacer)];
                case 6:
                    _d.sent();
                    return [4 /*yield*/, (0, fs_extra_1.ensureDir)("".concat(outputPath, "/queries"))];
                case 7:
                    _d.sent();
                    return [4 /*yield*/, (0, generate_queries_1.generateQueries)(queryObject.fields, fetcherPath, outputPath)];
                case 8:
                    _d.sent();
                    return [4 /*yield*/, (0, fs_extra_1.ensureDir)("".concat(outputPath, "/mutations"))];
                case 9:
                    _d.sent();
                    return [4 /*yield*/, (0, generate_mutations_1.generateMutations)(types, mutationObject.fields, fetcherPath, outputPath)];
                case 10:
                    _d.sent();
                    return [4 /*yield*/, (0, generate_output_code_chunks_1.generateOutputCodeChunks)(outputPath)];
                case 11:
                    _d.sent();
                    return [4 /*yield*/, (0, generate_index_1.generateIndexFile)(outputPath, queryObject, mutationObject)];
                case 12:
                    _d.sent();
                    return [2 /*return*/, { typesCount: count }];
            }
        });
    });
};
exports.generateFromUrl = generateFromUrl;
